/*
/--------------------------------------------------------------------
|
|      $Id: Filter.cpp,v 1.3 1999/11/27 18:45:48 Ulrich von Zadow Exp $
|
|      Copyright (c) 1996-1998 Ulrich von Zadow
|
\--------------------------------------------------------------------
*/

#include "stdpch.h"
#include "Filter.h"
#include "bitmap.h"
#include "anybmp.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CFilter::CFilter()
{

}

CFilter::~CFilter()
{

}

void CFilter::ApplyInPlace(CBmp * pBmp) 
{
  // Use a bitmap class that's guaranteed to work for all platforms as
  // temporary storage.
  CAnyBmp TempBmp;  
  Apply (pBmp, &TempBmp);
  pBmp->CreateCopy (TempBmp);
}

void CFilter::Apply(CBmp * pBmpSource, CBmp * pBmpDest)
{
  pBmpDest->CreateCopy (*pBmpSource);
  ApplyInPlace (pBmpDest);
}

/*
/--------------------------------------------------------------------
|
|      $Log: Filter.cpp,v $
|      Revision 1.3  1999/11/27 18:45:48  Ulrich von Zadow
|      Added/Updated doc comments.
|
|      Revision 1.2  1999/10/21 18:48:03  Ulrich von Zadow
|      no message
|
|      Revision 1.1  1999/10/21 16:05:17  Ulrich von Zadow
|      Moved filters to separate directory. Added Crop, Grayscale and
|      GetAlpha filters.
|
|      Revision 1.1  1999/10/19 21:29:44  Ulrich von Zadow
|      Added filters.
|
|
\--------------------------------------------------------------------
*/
