/*
/--------------------------------------------------------------------
|
|      $Id: PcxDec.h,v 1.2 1999/11/27 18:45:48 Ulrich von Zadow Exp $
|
|      Copyright (c) 1996-1998 Ulrich von Zadow
|
\--------------------------------------------------------------------
*/

#ifndef INCL_PCXDEC
#define INCL_PCXDEC

#ifndef INCL_PICDEC
#include "picdec.h"
#endif

#ifndef INCL_GIF
#include "Pcx.h"
#endif

//! PCX file decoder. Decodes 8, 15, 16, 24 and 32 bpp
//! PCX files (compressed and uncompressed) and returns an 8 or 32
//! bpp CBitmap. Preserves the alpha channel.
class CPCXDecoder : public CPicDecoder
{

DECLARE_DYNAMIC (CPCXDecoder);

public:
  //! Creates a decoder
  CPCXDecoder
    ();

  //! Destroys a decoder
  virtual ~CPCXDecoder
    ();

protected:
  //! Main decoder routine. Reads the header, Creates the bitmap,
  //! reads the palette, and reads the image data.
  virtual void DoDecode
    ( CBmp * pBmp,
      RGBAPIXEL ** ppPal,
      int * pDestBPP,
      CDataSource * pDataSrc
    );

private:
	void PCX_PlanesToPixels(LPBYTE pixels, LPBYTE bitplanes, 
		short bytesperline, short planes, short bitsperpixel);
	void PCX_UnpackPixels(LPBYTE pixels, LPBYTE bitplanes, 
		short bytesperline, short planes, short bitsperpixel);
};

#endif

/*
/--------------------------------------------------------------------
|
|      $Log: PcxDec.h,v $
|      Revision 1.2  1999/11/27 18:45:48  Ulrich von Zadow
|      Added/Updated doc comments.
|
|
\--------------------------------------------------------------------
*/
