/*
/--------------------------------------------------------------------
|
|      $Id: tiffdecex.h,v 1.1 1999/10/19 21:30:42 Ulrich von Zadow Exp $
|
|      Copyright (c) 1996-1998 Ulrich von Zadow
|
\--------------------------------------------------------------------
*/

#ifndef INCL_TIFFDECEX
#define INCL_TIFFDECEX

#include "tiffdec.h"

//! Modest interface to get access to tagged fields
//! This should move to CTiffDecoder but I dare not re-introduce 
//! data members in the reworked thread-safe base decoder
class CTIFFDecoderEx : public CTIFFDecoder
{
DECLARE_DYNAMIC (CTIFFDecoderEx);

public:
  CTIFFDecoderEx();
  ~CTIFFDecoderEx();
  BOOL Associate( CDataSource * pDataSrc );
  void Dissociate();
  int GetField( int tag_id, ... );

protected:
  virtual void DoDecode
    ( CBmp * pBmp,
      RGBAPIXEL ** ppPal,
      int * pDestBPP,
      CDataSource * pDataSrc
    );

private:
  TIFF* m_TiffToken;
};

#endif
/*
/--------------------------------------------------------------------
|
|      $Log: tiffdecex.h,v $
|      Revision 1.1  1999/10/19 21:30:42  Ulrich von Zadow
|      B. Delmee - Initial revision
|
|
--------------------------------------------------------------------
*/
