/*
/--------------------------------------------------------------------
|
|      $Id: Doc.h,v 1.4 1999/11/08 22:15:05 Ulrich von Zadow Exp $
|      Document class declaration
|
|      Copyright (c) 1998 Bernard Delme
|
\--------------------------------------------------------------------
*/

#ifndef INCL_DOCUMENT
#define INCL_DOCUMENT

#include "dibvfw.h"			// DrawDib windows bitmap

// Jo Hagelberg 15.4.99: inherit from IProgressNotification
#include "prognot.h"

#ifdef _NO_DRAWDIB
#	define CBmpClass CWinBmp
#else
#	define CBmpClass CDrawDibBmp
#endif

// Jo Hagelberg 15.4.99: inherit from IProgressNotification
class CPLViewerDoc : public CDocument, IProgressNotification
{
protected: // create from serialization only
	CPLViewerDoc();
	DECLARE_DYNCREATE(CPLViewerDoc)

// Attributes
public:
	CSize GetDocSize()
	    { return m_pDib->GetSize(); }
#ifndef _IGNORES_PALETTE
	CPalette* GetDocPalette()
	    { return m_pDib->GetLogPalette(); }
#endif

// Operations
public:
	virtual void DeleteContents();
	CBmpClass *GetDib() { return m_pDib; }
  // Jo Hagelberg 15.4.99: copied OnProgress from DibStatic
  void OnProgress( double Part);

// Implementation
protected:
	virtual ~CPLViewerDoc();
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);

protected:
	CBmpClass *m_pDib;

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// virtual BOOL OnSaveDocument( LPCTSTR lpszPathName );

// Generated message map functions
protected:
	//{{AFX_MSG(CPLViewerDoc)
	afx_msg void OnFileSave();
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif	// INCL_DOCUMENT
/*
/--------------------------------------------------------------------
|
|      $Log: Doc.h,v $
|      Revision 1.4  1999/11/08 22:15:05  Ulrich von Zadow
|      Added File/SaveAs
|
|
--------------------------------------------------------------------
*/
